# ėpCxgXNvgW[
# Author:: fukuyama
# Date:: 2005/12/03
# Copyright:: Copyright (C) 2005 fukuyama

# ėpCxgXNvgW[
module Event_Script
  
  # EBhER}hCX^X
  @@window_command = nil
  
  module_function
  
  # Vvj[J
  # width:: EBhE̕
  # commands:: R}h̔z
  # Return:: ꂽ Window_Command CX^X
  def open_simple_menu(width, commands)
    if @@window_command.nil?
      @@window_command = Window_Command.new(width, commands)
      @@window_command.screen_center
    end
    return @@window_command
  end
  
  # JVvj[XV
  # variable_id:: Iꂽڂ̃CfbNXۑϐ̂hc
  # Return:: pꍇ́Afalse
  def update_simple_menu(variable_id)
    @@window_command.update
    if Input.trigger? Input::B
      Variables[variable_id] = -1
      @@window_command.cancel_se
      @@window_command.dispose
      @@window_command = nil
      Input.update
      return true
    end
    if Input.trigger? Input::C
      Variables[variable_id] = @@window_command.index
      @@window_command.decision_se
      @@window_command.dispose
      @@window_command = nil
      Input.update
      return true
    end
    return false
  end
  
  Multi_Menu = Struct.new(:window, :commands)
  @@window_multi_menu = {}
  
  # }`j[J
  # name:: EBhE
  # width:: EBhE̕
  # commands:: R}h̔z
  # Return:: ꂽ Window_Command CX^X
  def open_multi_menu(name, width, commands)
    unless @@window_multi_menu.include? name
      menu = Multi_Menu.new
      menu.window = Window_Command.new(width, commands)
      menu.commands = commands
      @@window_multi_menu[name] = menu
    end
    return @@window_multi_menu[name].window
  end
  
  # }`j[
  # name:: EBhE
  def close_multi_menu(name=nil)
    return close_all_multi_menu() if name.nil?
    return true unless @@window_multi_menu.include? name
    menu = @@window_multi_menu.delete(name)
    menu.window.dispose
    return true
  end
  
  # }`j[Sĕ
  def close_all_multi_menu()
    @@window_multi_menu.each_value do |menu|
      menu.window.dispose
    end
    @@window_multi_menu.clear
    return true
  end
  
  # }`j[̒l擾
  # name:: EBhE
  def get_multi_menu_select(name)
    return nil unless @@window_multi_menu.include? name
    menu = @@window_multi_menu[name]
    return nil if menu.window.index < 0
    return menu.commands[menu.window.index]
  end
  
  # }`j[XV
  # name:: EBhE
  def update_multi_menu(name)
    return true unless @@window_multi_menu.include? name
    window = @@window_multi_menu[name].window
    window.update
    if Input.trigger? Input::B
      window.index = -1
      window.cancel_se
      Input.update
      return true
    end
    if Input.trigger? Input::C
      window.decision_se
      Input.update
      return true
    end
    return false
  end
  
  # }bṽLN^[w肵ʒuֈړ
  # id:: -1:vC[  0:̃Cxg  ̑:w̃Cxg
  # x:: x ΍W
  # y:: y ΍W
  # flag:: 'x': wWD悷(ftHg) 'y': xWD悷
  def move_to_abs(id,x,y,flag='x')
    # vbN̍쐬
    procs = {}
    procs['x'] = proc do |x,y,move_route|
      # ړR}hݒ 1: 2: 3:E 4:
      x_code = x > 0 ? 3 : 2
      y_code = y > 0 ? 1 : 4
      for i in 0 ... x.abs
        move_route.list.push RPG::MoveCommand.new(x_code)
      end
      for i in 0 ... y.abs
        move_route.list.push RPG::MoveCommand.new(y_code)
      end
    end
    procs['y'] = proc do |x,y,move_route|
      # ړR}hݒ 1: 2: 3:E 4:
      x_code = x > 0 ? 3 : 2
      y_code = y > 0 ? 1 : 4
      for i in 0 ... y.abs
        move_route.list.push RPG::MoveCommand.new(y_code)
      end
      for i in 0 ... x.abs
        move_route.list.push RPG::MoveCommand.new(x_code)
      end
    end
    
    # LN^[̎擾
    character = $game_system.map_interpreter.get_character(id)
    
    tx = x - character.x
    ty = y - character.y
    
    # ړ[g쐬
    move_route = RPG::MoveRoute.new
    move_route.repeat = false # JԂȂ
    move_route.skippable = true # ړłȂ疳
    # ړ[g̃R}h쐬
    move_route.list = []
    
    # vbNs
    procs[flag].call(tx,ty,move_route)
    
    # Ō͋̂Ă(Ip)
    move_route.list.push RPG::MoveCommand.new
    
    # ړ[g̋
    character.force_move_route(move_route)
  end
  
  # }bṽLN^[w肵ʒuփWv
  # id:: -1:vC[  0:̃Cxg  ̑:w̃Cxg
  # x:: x ΍W
  # y:: y ΍W
  def jump_to_abs(id,x,y)
    # LN^[̎擾
    character = $game_system.map_interpreter.get_character(id)
    
    tx = x - character.x
    ty = y - character.y
    
    # ړ[g쐬
    move_route = RPG::MoveRoute.new
    move_route.repeat = false # JԂȂ
    move_route.skippable = true # ړłȂ疳
    
    # ړ[g̃R}h쐬
    move_route.list = []
    
    # Wv:14
    move_route.list.push RPG::MoveCommand.new(14,[tx,ty])
    
    # Ō͋̂Ă(Ip)
    move_route.list.push RPG::MoveCommand.new
    
    # ړ[g̋
    character.force_move_route(move_route)
  end
  
  # ʂ̃Cxghc`FbN
  def check_event_id_there(id)
    d = $game_player.direction
    x = $game_player.x + (d == 6 ? 1 : d == 4 ? -1 : 0)
    y = $game_player.y + (d == 2 ? 1 : d == 8 ? -1 : 0)
    return $game_map.check_event(x,y) == id
  end
  
  # TODO Ƃ肠
  @@party_order = []
  
  # p[eB̕тۑ
  def save_party_order
    @@party_order = $game_party.actors.dup
    return true
  end
  
  # p[eB̕т𕜋A
  def load_party_order
    change_party_order(@@party_order)
    return true
  end
  
  # p[eB̕тύX
  def change_party_order(order)
    $game_party.actors.clear
    for actor in order
      case actor
      when Integer
        $game_party.actors.push $game_actors[actor]
      when Game_Actor
        $game_party.actors.push actor
      end
    end
    $game_player.refresh
    return true
  end
  
  # }bv}[W
  def map_blt(x, y, src_map_id, src_rect,layer=[0,1,2])
    src_map = load_data(sprintf("Data/Map%03d.rxdata", src_map_id))
    sx = src_rect.x
    sy = src_rect.y
    for ix in 0 ... src_rect.width
      for iy in 0 ... src_rect.height
        for l in layer
          $game_map.data[x + ix,y + iy,l] = src_map.data[sx + ix,sy + iy,l]
        end
      end
    end
  end
  
end
ES = Event_Script
